public class NDamen {
  // Alle Lsungen des N-Damen-Problems

  static int   n = 5;
  static int   anzahl = 0;

  static void Ausgabe (int[] d) {
    System.out.print(" ");
    for (int j = 1; j <= n; j++)
      System.out.print(d[j]);
    System.out.print(" ");
    } // Ende Ausgabe

  static boolean sicher (int zeile, int spalte, int[] dZeile) {
    // prft, ob Dame sicher (unbedroht) steht
    for (int k = 1; k < spalte; k++)
      if (dZeile[spalte - k] == zeile ||
          dZeile[spalte - k] == zeile - k ||
          dZeile[spalte - k] == zeile + k)
        return false;
    return true;
    } // Ende sicher

  static void sucheLsung (int spalte, int[] dZeile) {
    if (spalte > n)
      {anzahl++; Ausgabe(dZeile);}
    else {
      for (int zeile = 1; zeile <= n; zeile++) {
        dZeile[spalte] = zeile;
        if (sicher(zeile, spalte, dZeile))
          sucheLsung(spalte + 1, dZeile);
        } // Ende for
      } // Ende else
    } // Ende sucheLsung

  public static void main (String[] eingabe) {
    if (eingabe.length > 0)
      n = Integer.parseInt(eingabe[0]);
    System.out.println();
    sucheLsung(1, new int[n + 1]);
    System.out.println("\n\n " + anzahl + " Ergebnisse");
    } // Ende main

  } // Ende NDamen