public class Baumdemo {
  // ermglicht das Wandern im Suchbaum

  static int n;

  static void warte (int ms) {
    try {Thread.sleep(ms);}
    catch (InterruptedException e) {}
    } // Ende warte

  static void platziereDame (Spielposition pos) {
    if (pos.Ende())
      System.out.println("Endposition!");
    else
      for (int zeile = 1; zeile <= n; zeile++) {
        Spielzug zug = new Spielzug(zeile, pos);
        if (zug.zulssig()) {
          Spielposition p = zug.ausgefhrt();
          p.Kurzdarstellung(); warte(500);
          platziereDame(p);
          } // Ende if
        } // Ende for
    } // Ende platziereDame

  public static void main (String[] eingabe) {

    n = 4;
    Spielposition.setzReihenzahl(n);
    Spielposition pos = Spielposition.Anfang();

    int anzahl = eingabe.length;
    if (anzahl > 0) {
      n = anzahl;
      Spielposition.setzReihenzahl(n);
      pos = Spielposition.Anfang();
      for (int i = 0; i < anzahl; i++) 
        pos.setzDame(Integer.parseInt(eingabe[i]), i + 1);
      } // Ende if

    System.out.println();
    pos.Kurzdarstellung();

    platziereDame(pos);
    System.out.println();

    } // Ende main

  } // Ende Baumdemo